gtkmm 4.7.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::FlattenListModel Class Reference

A list model that flattens a list of lists. More...

`#include <gtkmm/flattenlistmodel.h>`

Inheritance diagram for Gtk::FlattenListModel:
[legend]

## Public Member Functions
| FlattenListModel (FlattenListModel && src) noexcept
FlattenListModel & | operator= (FlattenListModel && src) noexcept
| ~FlattenListModel () noexcept override
GtkFlattenListModel * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkFlattenListModel * | gobj () const
| Provides access to the underlying C GObject. More...
GtkFlattenListModel * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_model (const Glib::RefPtr< Gio::ListModel > & model)
| Sets a new model to be flattened. More...
Glib::RefPtr< Gio::ListModel > | get_model ()
| Gets the model set via set_model(). More...
Glib::RefPtr< const Gio::ListModel > | get_model () const
| Gets the model set via set_model(). More...
Glib::RefPtr< Gio::ListModel > | get_model_for_item (guint position)
| Returns the model containing the item at the given position. More...
Glib::PropertyProxy_ReadOnly< GType > | property_item_type () const
| The type of items. More...
Glib::PropertyProxy< Glib::RefPtr< Gio::ListModel > > | property_model ()
| The model being flattened. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::ListModel > > | property_model () const
| The model being flattened. More...
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_items () const
| The number of items. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::ListModel
| ListModel (ListModel &&src) noexcept
ListModel & | operator= (ListModel &&src) noexcept
| ~ListModel () noexcept override
GListModel * | gobj ()
const GListModel * | gobj () const
GType | get_item_type () const
guint | get_n_items () const
Glib::RefPtr< Glib::ObjectBase > | get_object (guint position)
Glib::RefPtr< const Glib::ObjectBase > | get_object (guint position) const
Glib::SignalProxy< void(guint, guint, guint)> | signal_items_changed ()
Glib::RefPtr< Gio::ListModel > | wrap (GListModel *object, bool take_copy=false)
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< FlattenListModel > | create (const Glib::RefPtr< Gio::ListModel > & model)
Static Public Member Functions inherited from Gio::ListModel
static void | add_interface (GType gtype_implementer)
static GType | get_type ()

## Protected Member Functions
| FlattenListModel (const Glib::RefPtr< Gio::ListModel > & model)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gio::ListModel
| ListModel ()
void | items_changed (guint position, guint removed, guint added)
virtual GType | get_item_type_vfunc ()
virtual guint | get_n_items_vfunc ()
virtual gpointer | get_item_vfunc (guint position)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::FlattenListModel > | wrap (GtkFlattenListModel * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A list model that flattens a list of lists.

Gtk::FlattenListModel is a list model that takes a list model containing list models and flattens it into a single model.

Another term for this is concatenation: Gtk::FlattenListModel takes a list of lists and concatenates them into a single list.

See also
  Gio::ListModel

Since gtkmm 3.98:

## Constructor & Destructor Documentation

## ◆ FlattenListModel() [1/2]

Gtk::FlattenListModel::FlattenListModel | ( | FlattenListModel && | src | ) |
| noexcept

## ◆ ~FlattenListModel()

Gtk::FlattenListModel::~FlattenListModel | ( |  | ) |
| override noexcept

## ◆ FlattenListModel() [2/2]

Gtk::FlattenListModel::FlattenListModel | ( | const Glib::RefPtr< Gio::ListModel > & | model | ) |
| explicit protected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr<FlattenListModel> Gtk::FlattenListModel::create | ( | const Glib::RefPtr< Gio::ListModel > & | model | ) |
| static

## ◆ get_model() [1/2]

Glib::RefPtr<Gio::ListModel> Gtk::FlattenListModel::get_model | ( |  | ) |

Gets the model set via set_model().

Returns
  The model flattened by self.

## ◆ get_model() [2/2]

Glib::RefPtr<const Gio::ListModel> Gtk::FlattenListModel::get_model | ( |  | ) | const

Gets the model set via set_model().

Returns
  The model flattened by self.

## ◆ get_model_for_item()

Glib::RefPtr<Gio::ListModel> Gtk::FlattenListModel::get_model_for_item | ( | guint | position | ) |

Returns the model containing the item at the given position.

Parameters

  position | A position.

Returns
  The model containing the item at position.

## ◆ get_type()

static GType Gtk::FlattenListModel::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkFlattenListModel* Gtk::FlattenListModel::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkFlattenListModel* Gtk::FlattenListModel::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkFlattenListModel* Gtk::FlattenListModel::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

FlattenListModel& Gtk::FlattenListModel::operator= | ( | FlattenListModel && | src | ) |
| noexcept

## ◆ property_item_type()

Glib::PropertyProxy_ReadOnly< GType > Gtk::FlattenListModel::property_item_type | ( |  | ) | const

The type of items.

See Gio::ListModel::get_item_type().

Since gtkmm 4.8:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [1/2]

Glib::PropertyProxy< Glib::RefPtr<Gio::ListModel> > Gtk::FlattenListModel::property_model | ( |  | ) |

The model being flattened.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gio::ListModel> > Gtk::FlattenListModel::property_model | ( |  | ) | const

The model being flattened.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_n_items()

Glib::PropertyProxy_ReadOnly< unsigned int > Gtk::FlattenListModel::property_n_items | ( |  | ) | const

The number of items.

See Gio::ListModel::get_n_items().

Since gtkmm 4.8:

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_model()

void Gtk::FlattenListModel::set_model | ( | const Glib::RefPtr< Gio::ListModel > & | model | ) |

Sets a new model to be flattened.

Parameters

  model | The new model.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::FlattenListModel > wrap | ( | GtkFlattenListModel * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.